
var fs = require('fs')
var path = require('path')
var spawn = require('child_process').spawn

var tempy = require('tempy')
var csv = require('csv-parser')
var through2Batch = require('through2-batch')

var xlsx2csvPY = path.resolve(__dirname, 'xlsx2csv.py')

var streamify = function (buffer) {
    var filename = tempy.file()
    fs.writeFileSync(filename, buffer, 'buffer')
	var stream = spawn('python', [xlsx2csvPY, '--ignoreempty', filename])

	var error = function (e) {
		stream.stdout.emit('error', e)
	}

	stream.stderr.on('data', function (e) {
		error(new Error(e.toString()))
	})
	stream.on('error', error)
	stream.on('close', function () {
		try {
			fs.unlinkSync(filename)
		} catch (e) {
		}
	})

	return stream.stdout
}

exports.streamify = streamify

var scrollcsv = function (stream, worker, payload, options) {
	payload = payload || 1

	return new Promise(function (resolve, reject) {

		stream
		.on('error', reject)
		.pipe(csv(options))
		.pipe(through2Batch.obj({batchSize: payload}, function (batch, enc, callback) {
		  Promise.resolve()
		  .then(function () { return worker(batch)})
		  .then(function () { callback() })
		  .catch(reject)
		}, resolve))
	})


}

exports.scrollcsv = scrollcsv

var scroll = function (buffer, worker, payload, options) {
	var stream = streamify(buffer)
	return scrollcsv(stream, worker, payload, options)
}

exports.scroll = scroll
